com.io7m.r2.core.shaders.provided

## Class R2RefractionMaskedDeltaParameters

- java.lang.Object
- - com.io7m.r2.core.shaders.provided.R2RefractionMaskedDeltaParameters

- All Implemented Interfaces:
    R2RefractionMaskedDeltaParametersType

      @Generated(value={"Immutables.generator","R2RefractionMaskedDeltaParametersType"})
      public final class R2RefractionMaskedDeltaParameters
      extends Object
      implements R2RefractionMaskedDeltaParametersType

  Parameters for the refractive masked delta shader.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `R2RefractionMaskedDeltaParameters.Builder` Builds instances of type `R2RefractionMaskedDeltaParameters`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static R2RefractionMaskedDeltaParameters.Builder` | `builder()` Creates a builder for `R2RefractionMaskedDeltaParameters`.
    `com.io7m.jtensors.parameterized.PVectorI3F<R2SpaceRGBType>` | `color()`
    `static R2RefractionMaskedDeltaParameters` | `copyOf(R2RefractionMaskedDeltaParametersType instance)` Creates an immutable copy of a `R2RefractionMaskedDeltaParametersType` value.
    `R2Texture2DUsableType` | `deltaTexture()`
    `boolean` | `equals(Object another)` This instance is equal to all instances of `R2RefractionMaskedDeltaParameters` that have equal attribute values.
    `int` | `hashCode()` Computes a hash code from attributes: `scale`, `color`, `sceneTexture`, `maskTexture`, `deltaTexture`.
    `R2Texture2DUsableType` | `maskTexture()`
    `static R2RefractionMaskedDeltaParameters` | `of(float scale, com.io7m.jtensors.parameterized.PVectorI3F<R2SpaceRGBType> color, R2Texture2DUsableType sceneTexture, R2Texture2DUsableType maskTexture, R2Texture2DUsableType deltaTexture)` Construct a new immutable `R2RefractionMaskedDeltaParameters` instance.
    `float` | `scale()` The scale value applied to vectors for the refraction effect.
    `R2Texture2DUsableType` | `sceneTexture()`
    `String` | `toString()` Prints the immutable value `R2RefractionMaskedDeltaParameters` with attribute values.
    `R2RefractionMaskedDeltaParameters` | `withColor(com.io7m.jtensors.parameterized.PVectorI3F<R2SpaceRGBType> value)` Copy the current immutable object by setting a value for the `color` attribute.
    `R2RefractionMaskedDeltaParameters` | `withDeltaTexture(R2Texture2DUsableType value)` Copy the current immutable object by setting a value for the `deltaTexture` attribute.
    `R2RefractionMaskedDeltaParameters` | `withMaskTexture(R2Texture2DUsableType value)` Copy the current immutable object by setting a value for the `maskTexture` attribute.
    `R2RefractionMaskedDeltaParameters` | `withScale(float value)` Copy the current immutable object by setting a value for the `scale` attribute.
    `R2RefractionMaskedDeltaParameters` | `withSceneTexture(R2Texture2DUsableType value)` Copy the current immutable object by setting a value for the `sceneTexture` attribute.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### scale

          public float scale()

      The scale value applied to vectors for the refraction effect. The effect works purely in screen-space and passing in a too-large value here will typically result in artifacts.
      Specified by:
        `scale` in interface `R2RefractionMaskedDeltaParametersType`
      Returns:
        A value by which to scale delta vectors for refraction

    - #### color

          public com.io7m.jtensors.parameterized.PVectorI3F<R2SpaceRGBType> color()

      Specified by:
        `color` in interface `R2RefractionMaskedDeltaParametersType`
      Returns:
        A color value by which to multiply the final refracted image

    - #### sceneTexture

          public R2Texture2DUsableType sceneTexture()

      Specified by:
        `sceneTexture` in interface `R2RefractionMaskedDeltaParametersType`
      Returns:
        The scene texture that will be used as the source of refraction

    - #### maskTexture

          public R2Texture2DUsableType maskTexture()

      Specified by:
        `maskTexture` in interface `R2RefractionMaskedDeltaParametersType`
      Returns:
        The mask texture that will be used to control sampling

    - #### deltaTexture

          public R2Texture2DUsableType deltaTexture()

      Specified by:
        `deltaTexture` in interface `R2RefractionMaskedDeltaParametersType`
      Returns:
        The delta texture that will be used as the source of refraction vectors

    - #### withScale

          public final R2RefractionMaskedDeltaParameters withScale(float value)

      Copy the current immutable object by setting a value for the `scale` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for scale
      Returns:
        A modified copy of the `this` object

    - #### withColor

          public final R2RefractionMaskedDeltaParameters withColor(com.io7m.jtensors.parameterized.PVectorI3F<R2SpaceRGBType> value)

      Copy the current immutable object by setting a value for the `color` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for color
      Returns:
        A modified copy of the `this` object

    - #### withSceneTexture

          public final R2RefractionMaskedDeltaParameters withSceneTexture(R2Texture2DUsableType value)

      Copy the current immutable object by setting a value for the `sceneTexture` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for sceneTexture
      Returns:
        A modified copy of the `this` object

    - #### withMaskTexture

          public final R2RefractionMaskedDeltaParameters withMaskTexture(R2Texture2DUsableType value)

      Copy the current immutable object by setting a value for the `maskTexture` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for maskTexture
      Returns:
        A modified copy of the `this` object

    - #### withDeltaTexture

          public final R2RefractionMaskedDeltaParameters withDeltaTexture(R2Texture2DUsableType value)

      Copy the current immutable object by setting a value for the `deltaTexture` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
      Parameters:
        `value` - A new value for deltaTexture
      Returns:
        A modified copy of the `this` object

    - #### equals

          public boolean equals(Object another)

      This instance is equal to all instances of `R2RefractionMaskedDeltaParameters` that have equal attribute values.
      Overrides:
        `equals` in class `Object`
      Returns:
        `true` if `this` is equal to `another` instance

    - #### hashCode

          public int hashCode()

      Computes a hash code from attributes: `scale`, `color`, `sceneTexture`, `maskTexture`, `deltaTexture`.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        hashCode value

    - #### toString

          public String toString()

      Prints the immutable value `R2RefractionMaskedDeltaParameters` with attribute values.
      Overrides:
        `toString` in class `Object`
      Returns:
        A string representation of the value

    - #### of

          public static R2RefractionMaskedDeltaParameters of(float scale,
                                                             com.io7m.jtensors.parameterized.PVectorI3F<R2SpaceRGBType> color,
                                                             R2Texture2DUsableType sceneTexture,
                                                             R2Texture2DUsableType maskTexture,
                                                             R2Texture2DUsableType deltaTexture)

      Construct a new immutable `R2RefractionMaskedDeltaParameters` instance.
      Parameters:
        `scale` - The value for the `scale` attribute
        `color` - The value for the `color` attribute
        `sceneTexture` - The value for the `sceneTexture` attribute
        `maskTexture` - The value for the `maskTexture` attribute
        `deltaTexture` - The value for the `deltaTexture` attribute
      Returns:
        An immutable R2RefractionMaskedDeltaParameters instance

    - #### copyOf

          public static R2RefractionMaskedDeltaParameters copyOf(R2RefractionMaskedDeltaParametersType instance)

      Creates an immutable copy of a `R2RefractionMaskedDeltaParametersType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
      Parameters:
        `instance` - The instance to copy
      Returns:
        A copied immutable R2RefractionMaskedDeltaParameters instance

    - #### builder

          public static R2RefractionMaskedDeltaParameters.Builder builder()

      Creates a builder for `R2RefractionMaskedDeltaParameters`.
      Returns:
        A new R2RefractionMaskedDeltaParameters builder

Copyright © 2017 <code@io7m.com> http://io7m.com